# Contributing to Design System

The following is a set of guidelines for contributing to Vue Design System. These are mostly guidelines, not rules. Use your best judgment, and feel free to propose changes to this document in a pull request.

## How to Contribute

1. When contributing, please first discuss the change(s) you wish to make via [an issue](https://github.com/viljamis/vue-design-system/issues/new) with Vue Design System team.
2. In most cases, we should be extending existing components instead of creating new ones. You might find [this diagram useful](https://coggle.it/diagram/V0hkiP976OIbGpy8/t/vanilla-pattern).
3. If you _really_ need to add a new component, please [review example component](https://github.com/viljamis/vue-design-system/blob/master/src/ExampleComponent.vue) first. It shows you how to structure and document your component.
4. If you wonder whether you should create an Element or a Pattern, ask yourself: _“can this be broken down into smaller pieces?”_ If the answer is yes, there’s a high chance that it should be a Pattern instead of an Element. For a more thorough explanation, [see terminology](https://github.com/viljamis/vue-design-system/wiki/terminology).
5. Components in the system are labelled with status labels that reflect their state of completion. Make sure to update the status on any component you work on. _[See an example](https://github.com/viljamis/vue-design-system/blob/master/src/ExampleComponent.vue#L8-L23)._
6. Finally, when you’re done, submit your pull request and ask someone from Vue Design System team to review it.
